/*
 * HTDialogOpcoes.java
 *
 * Created on 8 de Agosto de 2008, 16:56
 */

import java.awt.*;
import java.awt.Font;
import java.awt.event.*;
import java.awt.Graphics;
import java.util.Enumeration;

/**
 *
 * @author  Bruno
 */
public class HTDialogOpcoes extends java.awt.Dialog {

    HTDrawNode node;
    HTDraw model;
    int altura = 80;
    int NumChkBox = 0;
    boolean MostrarFolhas, MostrarFiguras, MostrarArcos;
    java.awt.Checkbox[] chk = new java.awt.Checkbox[10];

    /** Creates new form HTDialogOpcoes */
    public HTDialogOpcoes(java.awt.Frame parent, HTDrawNode no, int tipo, HTDraw md) {
        super(parent, no.getName(), false);
        node = no;
        model = md;
        CriaCheckBoxes(tipo, node.getNameImage());
        OrganizaForm();
    }

    // Funcao que cria os checkboxes
    private void CriaCheckBoxes(int tipo, String nameImagem) {

        /* Posicao 0 - figura
         *   Posicao 1 - Folder
         *   Posicao 2 - Arcos
         */
	  // tipo -> o mostra todos
        // tipo -> 1 no mostra exibir ns
        String hasFolder = node.getNodeClientData();
        
        if (hasFolder.length() <= 2)
        	hasFolder = hasFolder + "0";

        // Checkbox para Exibir Ns
        chk[NumChkBox] = new java.awt.Checkbox("Exibir ns folhas");

	  if (tipo==0) {
        	if (hasFolder.charAt(1) == '0') {	// Ns fechados
            	MostrarFolhas = false;
            	chk[NumChkBox].setState(false);
       	 } else {	// Ns abertos
            	MostrarFolhas = true;
            	chk[NumChkBox].setState(true);
        	}
	  }
	  else {
		MostrarFolhas = true;
            chk[NumChkBox].setState(true);
		chk[NumChkBox].enable(false);
	  }

        // Evento para pegar o click no checkbox para msotrar folhas
        chk[NumChkBox].addMouseListener(new java.awt.event.MouseAdapter() {

            public void mouseClicked(java.awt.event.MouseEvent evt) {
                if (MostrarFolhas) {
                    MostrarFolhas = false;
                } else {
                    MostrarFolhas = true;
                }
                CheckBoxClick(evt);
            }
        });
        /*
        chk[NumChkBox].addItemListener(new java.awt.event.ItemListener() {
        
        public void itemStateChanged(java.awt.event.ItemEvent evt) {
        if (MostrarFolhas) {
        MostrarFolhas = false;
        } else {
        MostrarFolhas = true;
        }
        }
        });*/
        this.add(chk[NumChkBox]);
        NumChkBox++;

        // Checkbox para Exibir Figuras
        chk[NumChkBox] = new java.awt.Checkbox("Exibir figuras");

        if (nameImagem != null && nameImagem.length() > 4) { 
        	if (hasFolder.charAt(0) == '0') {	// Ns fechados
            	MostrarFiguras = false;
            	chk[NumChkBox].setState(false);
        	} else {	// Ns abertos
            	MostrarFiguras = true;
            	chk[NumChkBox].setState(true);
        	}
	  }
	  else {
            chk[NumChkBox].setState(true);
		chk[NumChkBox].enable(false);
	 }

        // Evento para pegar o click no checkbox
        chk[NumChkBox].addMouseListener(new java.awt.event.MouseAdapter() {

            public void mouseClicked(java.awt.event.MouseEvent evt) {
                if (MostrarFiguras) {
                    MostrarFiguras = false;
                } else {
                    MostrarFiguras = true;
                }
                CheckBoxClick(evt);
            }
        });

        /*
        chk[NumChkBox].addItemListener(new java.awt.event.ItemListener() {
        
        public void itemStateChanged(java.awt.event.ItemEvent evt) {
        if (MostrarFiguras) {
        MostrarFiguras = false;
        } else {
        MostrarFiguras = true;
        }
        }
        }); */

        this.add(chk[NumChkBox]);
                
        NumChkBox++;
        // Checkbox para Mostrar arcos
        chk[NumChkBox] = new java.awt.Checkbox("Realar/Mostrar arcos");
        if (hasFolder.charAt(2) == '0') {	
        	MostrarArcos = false;
        	chk[NumChkBox].setState(false);
        } else {	// Ns abertos
        	MostrarArcos = true;
        	chk[NumChkBox].setState(true);
        }    
        	
        // Evento para pegar o click no checkbox
        chk[NumChkBox].addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                if (MostrarArcos) {
                    MostrarArcos = false;
                } else {
                    MostrarArcos = true;
                }
               
                CheckBoxClick(evt);
            }
        });

        this.add(chk[NumChkBox]);

    }

    // Coloca os componentes no form ;
    private void OrganizaForm() {
        String hasFolder = node.getNodeClientData();

        // Tamanho fixo
        this.setResizable(false);

        // Cores do form de acordo com o no
        this.setBackground(new Color(Color.decode(node.getColor()).getRGB()));
        this.setForeground(new Color(Color.decode(node.getTextColor()).getRGB()));

        addWindowListener(new java.awt.event.WindowAdapter() {

            public void windowClosing(java.awt.event.WindowEvent evt) {
                /* String valor = "11";
                if (!MostrarFolhas && !MostrarFiguras) {
                node.setNodeClientData("00");
                valor = "00";
                }
                if (!MostrarFolhas && MostrarFiguras) {
                node.setNodeClientData("10");
                valor = "10";
                }
                if (MostrarFolhas && !MostrarFiguras) {
                node.setNodeClientData("01");
                valor = "01";
                }
                if (MostrarFolhas && MostrarFiguras) {
                node.setNodeClientData("11");
                valor = "11";
                }
                
                node.setNodeClientStatus(valor);*/
                
        	                        
                dispose();
               
            }
        });

        // Layout do form -  (Linhas, Coluna)
        this.setLayout(new java.awt.GridLayout(NumChkBox + 1, 1));

        // Posicao do form
        HTCoordS zs = node.getScreenCoordinates();
        this.setBounds(zs.x - 10, zs.y + 150, 50, (40 + (20 * NumChkBox)));

        pack();
    }
    // Funcao que pega o click do mouse
    private void CheckBoxClick(java.awt.event.MouseEvent evt) {
        String valor = "11";
       
        if (!MostrarFolhas && !MostrarFiguras) {
            node.setNodeClientData("00");
            valor = "00";
        }
        if (!MostrarFolhas && MostrarFiguras) {
            node.setNodeClientData("10");
            valor = "10";
        }
        if (MostrarFolhas && !MostrarFiguras) {
            node.setNodeClientData("01");
            valor = "01";
        }
        if (MostrarFolhas && MostrarFiguras) {
            node.setNodeClientData("11");
            valor = "11";
        }
        
        if (MostrarArcos) 
        	valor = valor + "1";
        else
        	valor = valor + "0";
        
        node.setNodeClientData(valor);         
        node.setNodeClientStatus(valor);  
        model.folderFechadoGraphLine(node);
        model.reDraw();
         
        dispose();
    }
}
