
import java.util.*;

/**
 *  Description of the Class
 *
 * @author     Silvio Evangelista
 * @created    10 de Setembro de 2008
 */
public class HTMessage {


    int numLines =0;
    int maximumWidth = 0;
    int maxWidthW =0;
    int idM  =0;
    private String asLinhas[];

    int ntNos		= 0;
    int ntNosFilhos	= 0;
    int ntBusca	= 0;

    /**
     *Constructor for the HTMessage object
     *
     * @param  m  Description of the Parameter
     */
    public HTMessage(String m, HTDrawNode node) {


        String linha="";
        int ind;
	  String asLinhasT[] = new String[66];
	  boolean isSearch   = node.getIsSearch(); // Verificar se est no modo search
	  boolean hasData = node.getHasData();     // Verificar se o n em questo possui ou no o dado que se est buscando


// ***********************
	  int cl = 0;
	  String pula="";

	  //asLinhasT[numLines] = "     ";
        //numLines = 1;

	int nF=0;	

	 if (!node.isLeafNode()) {
		nF    = percorreRamoConta(node.getNode(), isSearch, 0);	
	 }

	  for (int j=0; j < m.length(); j++) {
		if (j < (m.length()-5)) {
			pula = m.substring(j, j+5);
			if (pula.equals("&crlf") || (cl > 80 && m.charAt(j) == ' ')) {
				asLinhasT[numLines] = linha;
				numLines++;
				linha="";
				cl=0;
				if (pula.equals("&crlf"))
					j+=5;			
			}
		}
		if (numLines > 63)
			break;

		if (j >= m.length())
			break;

		linha = linha +  m.substring(j, j+1); // m.charAt(i);
		cl++;
	  }

	  if ((cl > 0) && (numLines < 64)) {
		asLinhasT[numLines] = linha;
		numLines++;
	  }

	  if (ntBusca > 0) {
			asLinhasT[numLines] =  "Total de ns com os termos de busca:" + " " + ntBusca ;
			numLines++;
	  }

        asLinhas = new String[numLines];
        int thisWidth;
        int index;

        for (int i = 0; i < numLines; i++) {
            asLinhas[i] = asLinhasT[i];
            thisWidth = asLinhas[i].length();
            if (thisWidth > maximumWidth) {
                maximumWidth = thisWidth;
                //idM = i;
            }
		int nn = node.getStringWidth(asLinhas[i]);
		if (maxWidthW <  nn) {
			maxWidthW = nn;
			idM = i;
		}

        }
        // setSizes();
    }
    // End
    /**
     *  Sets the sizes attribute of the HTMessage object
     */
    public void setSizes() {
        int thisWidth;
        int index;
        for (index = 0; index < numLines; index++) {
            thisWidth = asLinhas[index].length();
            if (thisWidth > maximumWidth) {
                maximumWidth = thisWidth;
                idM = index;
            }
        }
    }
    // End setSizes.
    /**
     *  Gets the idM attribute of the HTMessage object
     *
     * @return    The idM value
     */
    public int getIdM() {
        return idM;
    }

    public int getMaxWidthW () {
        return maxWidthW;
    }

    /**
     *  Gets the line attribute of the HTMessage object
     *
     * @param  i  Description of the Parameter
     * @return    The line value
     */
    public String getLine(int i) {
        return (asLinhas[i]);
    }

    /**
     *  Gets the numLines attribute of the HTMessage object
     *
     * @return    The numLines value
     */
    public int getNumLines() {
        return numLines;
    }

    /**
     *  Gets the maximumWidth attribute of the HTMessage object
     *
     * @return    The maximumWidth value
     */
    public int getMaximumWidth() {
        return maximumWidth;
    }

      public int percorreRamoConta(HTNode node, boolean iS, int nF) {
		int fi=0;
		for (Enumeration e = node.childrenNode(); e.hasMoreElements(); ) {
			HTNode childNode  = (HTNode) e.nextElement();
			if (!childNode.isLeafNode()) {												
				nF = nF + percorreRamoConta(childNode, iS, nF);	
				ntNosFilhos++;
				boolean hasData = childNode.getHasData();
				if (iS && hasData) ntBusca++;
				fi = nF;			

			} else {
				boolean hasData = childNode.getHasData();
				String  hint    = childNode.getHint();
				boolean cal     = false;		
				ntNosFilhos++;					

				if (!iS || (iS && hasData)) cal = true;

				if (iS && hasData) ntBusca++;

				if (cal) {
					ntNos++;					
					fi=fi+1;
				}
			}
		}
		return(fi);
	}

}

